#import "Hoppeta.h"

#import "GNActor.h"
#import "GNActorEnumerator.h"
#import "GNActorList.h"

@implementation GNActorList
- (id)initWithSize:(Sint32)aSize
{
	Sint32 i;

	[super init];

	listSize = aSize;
	list = malloc(sizeof(id) * listSize);
	for(i = 0;i < listSize;i++)
	{
		list[i] = nil;
	}

	return self;
}

- (void)process
{
	Sint32 i;

	for(i = 0;i < listSize;i++)
	{
		if(list[i] != nil)
		{
			[list[i] process];
		}
	}
}

- (void)draw
{
	Sint32 i;

	for(i = 0;i < listSize;i++)
	{
		if(list[i] != nil)
		{
			[list[i] draw];
		}
	}
}

- (BOOL)addActor:(id)actor
{
	Sint32 i;

	for(i = 0;i < listSize;i++)
	{
		if(list[i] == nil)
		{
			[actor retain];
			list[i] = actor;

			return YES;
		}
	}

	return NO;
}

- (void)remove:(id)actor
{
	Sint32 i;

	for(i = 0;i < listSize;i++)
	{
		if(list[i] == actor)
		{
			[list[i] release];
			list[i] = nil;

			return;
		}
	}
}

- (id)actorAtIndex:(Sint32)index
{
	return list[index];
}

- (id)actorWithUniqueID:(Uint32)uniqueID
{
	Sint32 i;

	for(i = 0;i < listSize;i++)
	{
		if(list[i] != nil && [list[i] uniqueID] == uniqueID)
		{
			return list[i];
		}
	}

	return nil;
}

- (id)actorEnumerator
{
	return [[[GNActorEnumerator alloc] initWithActorlist:self actorListSize:listSize] autorelease];
}

- (void)dealloc
{
	Sint32 i;

	for(i = 0;i < listSize;i++)
	{
		if(list[i] != nil)
		{
			[list[i] release];
		}
	}

	free(list);
	[super dealloc];
}
@end
