#import "Hoppeta.h"

#import "GNFader.h"

@implementation GNFader
- (id)init
{
	[super init];

	fadeType = GNFaderFadeTypeFadeOut;
	colorType = GNFaderColorTypeBlack;
	frameNum = 30;
	count = 0;
	processing = NO;
	done = NO;

	return self;
}

- (void)begin:(Sint32)aFadeType colorType:(Sint32)aColorType frameNum:(Sint32)aFrameNum
{
	fadeType = aFadeType;
	colorType = aColorType;
	frameNum = aFrameNum;
	count = 0;
	processing = YES;
	done = NO;
}

- (void)end
{
	processing = NO;
}

- (void)process
{
	if(processing == YES)
	{
		if(done == NO)
		{
			count++;
			if(count >= frameNum)
			{
				done = YES;
			}
		}
	}
}

- (void)draw
{
	float bright;
	float alpha;

	if(processing == YES)
	{
		if(fadeType == GNFaderFadeTypeFadeIn)
		{
			alpha = (float)(frameNum - count) / (float)frameNum;
			if(alpha < 0.0f)
			{
				alpha = 0.0f;
			}
		}
		else
		{
			alpha = (float)count / (float)frameNum;
			if(alpha > 1.0f)
			{
				alpha = 1.0f;
			}
		}

		glPushMatrix();
		glEnable(GL_BLEND);
		if(colorType == GNFaderColorTypeBlack)
		{
			bright = 0.0f;
			glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		}
		else
		{
			bright = 1.0f;
			glBlendFunc(GL_SRC_ALPHA,GL_ONE);
		}
		glBegin(GL_TRIANGLE_STRIP);
		glColor4f(bright,bright,bright,alpha);
		glVertex3f(0.0f,0.0f,0.0f);
		glColor4f(bright,bright,bright,alpha);
		glVertex3f(640.0f,0.0f,0.0f);
		glColor4f(bright,bright,bright,alpha);
		glVertex3f(0.0f,480.0f,0.0f);
		glColor4f(bright,bright,bright,alpha);
		glVertex3f(640.0f,480.0f,0.0f);
		glEnd();
		glDisable(GL_BLEND);
		glPopMatrix();
	}
}
@end
