#import "Hoppeta.h"

#import "GNCamera.h"
#import "GNScene.h"
#import "GNGonyNenga.h"
#import "GNActor.h"
#import "GNActorList.h"
#import "GNLogoDrawer.h"
#import "GNLogo.h"

typedef void (*GNLogoDrawerFunction)(void);

@implementation GNLogo
- (id)initWithPosition:(HPVector)aPosition characterIndex:(Sint32)aCharacterIndex red:(float)aRed green:(float)aGreen blue:(float)aBlue
{
	HPVector axis;

	[super init];
	position.x = aPosition.x;
	position.y = aPosition.y;
	position.z = aPosition.z;
	velocity.x = 0.0f;
	velocity.y = 0.0f;
	velocity.z = 0.0f;
	axis.x = 0.0f;
	axis.y = 1.0f;
	axis.z = 0.0f;
	direction = HPRotationMatrix(axis,180.0f);
    characterIndex = aCharacterIndex;
	red = aRed;
	green = aGreen;
	blue = aBlue;

	return self;
}

- (void)process
{
	HPVector cameraPosition;

	cameraPosition = [[[GNGonyNenga scene] camera] position];
	if(position.z < cameraPosition.z)
	{
		[[[GNGonyNenga scene] logoList] remove:self];
	}
}

- (void)draw
{
	static GNLogoDrawerFunction drawerFunction[] =
	{
		GNDrawLogoA,
		GNDrawLogoKe,
		GNDrawLogoMa,
		GNDrawLogoShi,
		GNDrawLogoTe,
		GNDrawLogoO,
		GNDrawLogoMe,
		GNDrawLogoDe,
		GNDrawLogoTo,
		GNDrawLogoU,
		GNDrawLogoGo,
		GNDrawLogoZa,
		GNDrawLogoI,
		GNDrawLogoMa,
		GNDrawLogoSu,
	};

	static float fogColor[4] = 
	{
		0.0f,
		0.0f,
		0.0f,
		1.0f
	};

	glPushMatrix();
	glTranslatef(position.x,position.y,position.z);
	glMultMatrixd(direction.data);
	glScalef(0.7f,0.7f,0.7f);
	glFogi(GL_FOG_MODE,GL_EXP2);
	glFogfv(GL_FOG_COLOR,fogColor);
	glFogf(GL_FOG_DENSITY,0.002f);
	glHint(GL_FOG_HINT,GL_DONT_CARE);
	glEnable(GL_FOG);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glColor3f(red,green,blue);
	drawerFunction[characterIndex]();
	glDisable(GL_BLEND);
	glDisable(GL_FOG);
	glPopMatrix();
}
@end
