#import "Hoppeta.h"

#import "GNGonyNenga.h"
#import "GNScene.h"
#import "GNCamera.h"
#import "GNSphere.h"

enum
{
	GNSphereVertexNumX = 9,
	GNSphereVertexNumY = 16,
};

static HPVector vertices[GNSphereVertexNumX][GNSphereVertexNumY];

@implementation GNSphere
- (id)init
{
	static HPVector xAxis =
	{
		1.0f,
		0.0f,
		0.0f
	};
	static HPVector yAxis =
	{
		0.0f,
		1.0f,
		0.0f,
	};
	static HPVector position =
	{
		0.0f,
		0.0f,
		200.0f,
	};

	HPMatrix xRotationMatrix;
	HPMatrix yRotationMatrix;
	HPMatrix rotationMatrix;
	Sint32 i;
	Sint32 j;
	float xAngle;
	float yAngle;

	[super init];
	for(i = 0;i <= 8;i++)
	{
		xAngle = i * 180.0f / 8.0f - 90.0f;
		xRotationMatrix = HPRotationMatrix(xAxis,xAngle);

		for(j = 0;j < 16;j++)
		{
			yAngle = j * 360.0f / 16.0f;
			yRotationMatrix = HPRotationMatrix(yAxis,yAngle);
			rotationMatrix = HPMultiplyMatrixes(yRotationMatrix,xRotationMatrix);

			vertices[i][j] = HPMultiplyMatrixVector(rotationMatrix,position);
		}
	}

	return self;
}

- (void)process
{
}

- (void)draw
{
	id camera;
	HPVector cameraPosition;
	HPVector aVertex;
	HPVector bVertex;
	Sint32 i;
	Sint32 j;

	camera = [[GNGonyNenga scene] camera];
	cameraPosition = [camera position];
	glPushMatrix();
	glTranslatef(cameraPosition.x,cameraPosition.y,cameraPosition.z);
	[[GNGonyNenga resource]->starTexture bind];
	for(i = 0;i < 8;i++)
	{
		glEnable(GL_TEXTURE_2D);
		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
		glBegin(GL_TRIANGLE_STRIP);
		for(j = 0;j <= 16;j++)
		{
			aVertex = vertices[i][j & 15];
			bVertex = vertices[i + 1][j & 15];
			glColor3f(1.0f,1.0f,1.0f);
			glTexCoord2f(j / 4.0f,i / 4.0f);
			glVertex3f(aVertex.x,aVertex.y,aVertex.z);
			glColor3f(1.0f,1.0f,1.0f);
			glTexCoord2f(j / 4.0f,(i + 1) / 4.0f);
			glVertex3f(bVertex.x,bVertex.y,bVertex.z);
		}
		glEnd();
		glDisable(GL_TEXTURE_2D);
	}
	glPopMatrix();
}
@end
