#import "Hoppeta.h"

#import "HPAutoreleasePool.h"

static id defaultAutoreleasePool = nil;

@implementation HPAutoreleasePool
+ (id)defaultAutoreleasePool
{
	if(defaultAutoreleasePool == nil)
	{
		defaultAutoreleasePool = [[HPAutoreleasePool alloc] init];
	}

	return defaultAutoreleasePool;
}

- (id)init
{
	bufferSize = 8;
	objectBuffer = malloc(sizeof(id) * bufferSize);
	memset(objectBuffer,0,sizeof(id) * bufferSize);
	objectNum = 0;

	return self;
}

- (void)addObject:(id)object
{
	Sint32 i;

	if(bufferSize <= objectNum)
	{
		objectBuffer = realloc(objectBuffer,sizeof(id) * bufferSize * 2);
		for(i = 0;i < bufferSize;i++)
		{
			objectBuffer[bufferSize + i] = nil;
		}
		bufferSize *= 2;
	}

	for(i = 0;i < bufferSize;i++)
	{
		if(objectBuffer[i] == nil)
		{
			objectBuffer[i] = object;
			objectNum++;

			// printf("-[HPAutoreleasePool addObject]: Object %08X added.\n",(unsigned int)object);

			return;
		}
	}
}

- (void)removeObject:(id)object
{
	Sint32 i;

	for(i = 0;i < bufferSize;i++)
	{
		if(objectBuffer[i] == object)
		{
			objectBuffer[i] = nil;
			objectNum--;

			return;
		}
	}
}

- (void)flush
{
	Sint32 i;

	for(i = 0;i < bufferSize;i++)
	{
		if(objectBuffer[i] != nil)
		{
			[objectBuffer[i] release];

			// printf("-[HPAutoreleasePool flush]: Object %08X released. self:%08X\n",(unsigned int)objectBuffer[i],(unsigned int)self);

			objectBuffer[i] = nil;
		}
	}
	objectNum = 0;
}

- (void)dealloc
{
	[self flush];
	free(objectBuffer);
	[super dealloc];
}
@end
