#import "Hoppeta.h"

#import "HPFont.h"

@implementation HPFont
- (id)init
{
	[super init];
	texture = [[HPTexture alloc] initWithFilename:"Font.bmp"];

	return self;
}

- (void)draw:(Sint8)character red:(GLfloat)red green:(GLfloat)green blue:(GLfloat)blue alpha:(GLfloat)alpha
{
	GLfloat vtx[8];
	GLfloat texcoord[8];
	GLfloat color[16];
	GLfloat * pvtx;
	GLfloat * ptexcoord;
	GLfloat * pcolor;
	GLfloat x;
	GLfloat y;

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	[texture bind];
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);
	glVertexPointer(2,GL_FLOAT,0,vtx);
	glTexCoordPointer(2,GL_FLOAT,0,texcoord);
	glColorPointer(4,GL_FLOAT,0,color);

	pvtx = vtx;
	ptexcoord = texcoord;

	x = (character & 15) * 8.0f;
	y = (character / 16) * 8.0f;

	*pvtx++ = 0.0f;
	*pvtx++ = 0.0f;
	*pvtx++ = 8.0f;
	*pvtx++ = 0.0f;
	*pvtx++ = 8.0f;
	*pvtx++ = 8.0f;
	*pvtx++ = 0.0f;
	*pvtx = 8.0f;
	*ptexcoord++ = (x - 0.5f) / 128.0f;
	*ptexcoord++ = (y - 0.5f) / 128.0f;
	*ptexcoord++ = (x + 7.5f) / 128.0f;
	*ptexcoord++ = (y - 0.5f) / 128.0f;
	*ptexcoord++ = (x + 7.5f) / 128.0f;
	*ptexcoord++ = (y + 7.5f) / 128.0f;
	*ptexcoord++ = (x - 0.5f) / 128.0f;
	*ptexcoord = (y + 7.5f) / 128.0f;
	pcolor = color;
	*pcolor++ = red;
	*pcolor++ = green;
	*pcolor++ = blue;
	*pcolor++ = alpha;
	*pcolor++ = red;
	*pcolor++ = green;
	*pcolor++ = blue;
	*pcolor++ = alpha;
	*pcolor++ = red;
	*pcolor++ = green;
	*pcolor++ = blue;
	*pcolor++ = alpha;
	*pcolor++ = red;
	*pcolor++ = green;
	*pcolor++ = blue;
	*pcolor++ = alpha;
	glDrawArrays(GL_QUADS,0,4);

	glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
}

- (void)drawText:(Sint8 *)text red:(GLfloat)red green:(GLfloat)green blue:(GLfloat)blue alpha:(GLfloat)alpha
{
	glPushMatrix();

	while(*text != '\0')
	{
		[self draw:*text red:red green:green blue:blue alpha:alpha];
		glTranslatef(8.0f,0.0f,0.0f);
		text++;
	}

	glPopMatrix();
}
@end
