#import "Hoppeta.h"

typedef struct _HPBMPHeader
{
	Sint32 filesize;
	Sint32 reserved;
	Sint32 bitmapOffset;
	Sint32 headerSize;
	Sint32 width;
	Sint32 height;
	Sint16 planeNum;
	Sint16 depth;
	Sint32 compress;
	Sint32 bitmapSize;
	Sint32 resolutionH;
	Sint32 resolutionV;
	Sint32 colorNum;
	Sint32 importantColorNum;
} HPBMPHeader;

BOOL HPSaveScreenBMP(char * filename,Sint32 positionX,Sint32 positionY,Sint32 width,Sint32 height)
{
	FILE * file;
	HPBMPHeader header;
	Uint8 * buffer;
	Uint8 * pixelAddr;
	Sint32 i;
	Sint32 pixelNum;
	Uint8 b;
	buffer = malloc(width * height * 3);
	if(buffer == NULL)
	{
		// 
		return NO;
	}

	header.filesize = 14 + 40 + width * height * 3;
	header.reserved = 0;
	header.bitmapOffset = 54;
	header.headerSize = 40;
	header.width = width;
	header.height = height;
	header.planeNum = 1;
	header.depth = 24;
	header.compress = 0;
	header.bitmapSize = width * height * 3;
	header.resolutionH = 0;
	header.resolutionV = 0;
	header.colorNum = 0;
	header.importantColorNum = 0;
	glReadPixels(positionX,positionY,width,height,GL_RGB,GL_UNSIGNED_BYTE,buffer);

	pixelNum = width * height;
	pixelAddr = buffer;
	for(i = 0;i < pixelNum;i++)
	{
		b = pixelAddr[0];
		pixelAddr[0] = pixelAddr[2];
		pixelAddr[2] = b;
		pixelAddr += 3;
	}
	file = fopen(filename,"wb");
	if(file == NULL)
	{
		return NO;
	}
	fwrite("BM",2,1,file);
	fwrite(&header,52,1,file);
	fwrite(buffer,width * height * 3,1,file);
	fclose(file);
	free(buffer);

	return YES;
}
