#import "Hoppeta.h"

#import "HPJoystick.h"

@implementation HPJoystick
- (id)init
{
	[super init];

	pressed = 0;
	trigger = 0;
	old = 0;

	return self;
}

- (void)update
{
	Uint8 * keyState;

	old = pressed;
	pressed = 0;
	keyState = SDL_GetKeyState(NULL);
	if(keyState[SDLK_UP])
	{
		pressed |= HPJoystickButtonUp;
	}
	if(keyState[SDLK_DOWN])
	{
		pressed |= HPJoystickButtonDown;
	}
	if(keyState[SDLK_LEFT])
	{
		pressed |= HPJoystickButtonLeft;
	}
	if(keyState[SDLK_RIGHT])
	{
		pressed |= HPJoystickButtonRight;
	}
	if(keyState[SDLK_z])
	{
		pressed |= HPJoystickButtonA;
	}
	if(keyState[SDLK_x])
	{
		pressed |= HPJoystickButtonB;
	}
	if(pressed & HPJoystickButtonUp && pressed & HPJoystickButtonDown)
	{
		pressed &= ~(HPJoystickButtonUp | HPJoystickButtonDown);
	}
	if(pressed & HPJoystickButtonLeft && pressed & HPJoystickButtonRight)
	{
		pressed &= ~(HPJoystickButtonLeft | HPJoystickButtonRight);
	}
	trigger = (pressed ^ old) & pressed;
}

- (Uint32)pressed
{
	return pressed;
}

- (Uint32)trigger
{
	return trigger;
}
@end
