#import "Hoppeta.h"

#import "HPObject.h"

@implementation HPObject
+ (id)new
{
	return [[self alloc] init];
}

+ (id)alloc
{
	id object;

	object = [super alloc];

	// printf("+[HPObject alloc]: Object %08X allocated.\n",(unsigned int)object);

	return object;
}

- (id)init
{
	[super init];
	autoreleasePool = [[HPAutoreleasePool alloc] init];
	retainCount = 1;

	return self;
}

- (id)free
{
	id object;

	object = self;

	[self dealloc];
	[super free];

	// printf("-[HPObject free]: Object %08X freed.\n",(unsigned int)object);

	return nil;
}

- (void)retain
{
	retainCount++;
}

- (void)release
{
	retainCount--;
	if(retainCount <= 0)
	{
		[self free];
	}
}

- (id)autorelease
{
	[[HPAutoreleasePool defaultAutoreleasePool] addObject:self];

	return self;
}

- (void)addChildObject:(id)object
{
	[autoreleasePool addObject:object];

	// printf("-[HPObject addChildObject]: Object %08X added as child. self:%08X\n",(unsigned int)object,(unsigned int)self);
}

- (void)removeChildObject:(id)object
{
	[autoreleasePool removeObject:object];
}

- (void)dealloc
{
	[autoreleasePool release];
}
@end
